<sys/_malloc.h>: Use basic integer types like in the rest of the header.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 BINUTILS 2.34 REPLACES 2.25, PRIMARY
16 ------------------------------------
17
18 The oldest of the two versions of Binutils, version 2.25, was removed
19 and replaced with Binutils 2.34.  It becomes the primary version of
20 binutils and version 2.27 becomes the alternate.
21
22 The accepted values of BINUTILSVER are now "binutils234" (default) and
23 "binutils227".  The building of Binutils 2.27 can be prevented by setting
24 NO_ALTBINUTILS=yes in make.conf
25
26 LIBRADIUS AND LIBTACPLUS REMOVED
27 --------------------------------
28
29 Both libraries have been moved from base to DPorts net/ category.
30
31 PAM_SSH MODULE REMOVED
32 ----------------------
33
34 The pam_ssh(8) have been removed from base to DPorts security/pam_ssh.
35
36 UTMP LEGACY API REMOVED
37 -----------------------
38
39 The legacy "utmp" API (getutent() and friends, utmp.h, etc.) has been
40 removed, and we are now using the POSIX "utmpx" API (getutxent(),
41 utmpx.h, etc.) only. The most visible change for users is that the
42 /var/log/wtmp file will no longer be written to, just /var/log/wtmpx.
43 The wtmpcvt(1) utility is provided to convert old wtmp format files to
44 wtmpx.
45
46 To not break old applications, the utmp symbols are still provided by
47 libc as dummy functions that do nothing and always succeed.
48
49 TIMED AND TIMEDC REMOVED
50 ------------------------
51
52 timed(8) and timedc(8) have been removed because they are beyond
53 obsolete for setting the time.
54
55 LIBOPIE, LIBMD REMOVED
56 ----------------------
57
58 Removal of OPIE requires /etc/pam.d/ configs to be updated.
59
60 +-----------------------------------------------------------------------+
61 +         UPGRADING DRAGONFLY FROM 5.4 TO LATER VERSIONS                +
62 +-----------------------------------------------------------------------+
63
64 GCC50 REMOVED
65 -------------
66
67 The GCC50 compiler has been retired.  It has been replaced by a GCC80.
68 The default alternative compiler has stayed the same - GCC47.
69
70
71 PUFFS, PUTTER AND LIBREFUSE REMOVED
72 -----------------------------------
73
74 The puffs(4)/putter(4) subsystem has been removed, along with librefuse,
75 libpuffs, and the mount_psshfs(8) utility. All of these have never been
76 working correctly.
77
78 FFS_ROOT OPTION REMOVED
79 -----------------------
80
81 The FFS_ROOT kernel configuration option has been finally removed, after
82 having been a no-op since 4.9. That means users using a custom kernel
83 configuration file that still contains it need to remove the option from
84 that file.
85
86 +-----------------------------------------------------------------------+
87 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
88 +-----------------------------------------------------------------------+
89
90 DIGI, RP AND SI DRIVERS REMOVED
91 -------------------------------
92
93 The digi(4), rp(4) and si(4) serial drivers have been removed. None of
94 them were in our default kernel configuration file. The sicontrol(8)
95 utility was removed, too.
96
97 MKINITRD COMMAND REMOVED
98 ------------------------
99
100 The mkinitrd(8) command is removed and its functionality is replaced by
101 the new "initrd" make target.  After rebooting into the new world and
102 verifying everything works, execute "make initrd" to upgrade the rescue
103 tools and initrd image.
104
105 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
106 --------------------------------------------------------------
107
108 IPsec has been removed from the system. Of our standard kernel
109 configurations, only the virtual kernel one had it. People running
110 vkernels with configuration files derived from our VKERNEL64 will
111 have to remove these options manually.
112
113 +-----------------------------------------------------------------------+
114 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
115 +-----------------------------------------------------------------------+
116
117 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
118 -------------------------------------
119
120 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
121 with configuration files derived from it have to remove it manually.
122
123 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
124 ----------------------------------------
125
126 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
127 For those that still need them, there is the net/bsdrcmds port.
128
129 VARIOUS FORMER OPTIONS REMOVED
130 ------------------------------
131
132 Various former kernel configuration options which had been no-ops for
133 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
134 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
135 their kernel configuration files have to remove them.
136
137 BOOTSTRAPPING LIMITED FROM PRE 4.4
138 ----------------------------------
139
140 Upgrading to 5.1 and later versions now require at least 4.4 in
141 preparations for upcoming base compilers updates.
142
143 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
144 ------------------------------------------
145
146 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
147 already been removed from our default kernel configuration before 5.0,
148 so only people with custom configurations based on earlier X86_64_GENERIC
149 will have to remove it manually.
150
151 The faith(4) interface has been completely removed after it had also
152 been removed from our default kernel configuration. 
153
154 +-----------------------------------------------------------------------+
155 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
156 +-----------------------------------------------------------------------+
157
158 FFS_ROOT OPTION DISABLED
159 ------------------------
160
161 The FFS_ROOT option has been made a no-op and will be completely removed
162 at some point in the future. Users with a custom kernel configuration
163 can remove this option from it now.
164
165 +-----------------------------------------------------------------------+
166 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
167 +-----------------------------------------------------------------------+
168
169 DSA OPENSSH KEYS DEPRECATED
170 ---------------------------
171
172 Note that DSA OpenSSH keys were deprecated in the 4.6 to 4.8 release. 
173 If you are upgrading from a release older than 4.8 and use DSA OpenSSH 
174 keys, please update your private/public key pair or risk locking 
175 yourself out.
176
177 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
178 -----------------------------------------------
179
180 They were all in our X86_64_GENERIC kernel configuration file, along with
181 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
182 configuration files derived from it need adjustment.
183
184 PORTAL FILE SYSTEM REMOVED
185 --------------------------
186
187 It has been broken for a long time now.
188
189 BINUTILS 2.27 REPLACES 2.24, PRIMARY
190 ------------------------------------
191
192 The oldest of the two versions of Binutils, version 2.24, was removed
193 and replaced with Binutils 2.27.  It becomes the primary version version
194 of binutils and version 2.25 becomes the alternate.
195
196 The accepted values of BINUTILSVER are now "binutils227" (default) and
197 "binutils225".  The building of Binutils 2.25 can be prevented by setting
198 NO_ALTBINUTILS=yes in make.conf.
199
200 COMPAT_43 KERNEL OPTION REMOVED
201 -------------------------------
202
203 It was commented out in our default configs for several years now, but
204 might still be present in custom configs created before Nov. 2011.
205
206 OPENSSL REMOVED
207 ---------------
208
209 OpenSSL has been removed from base and replaced with a private version of
210 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
211 pages will remain on the system unless the "make upgrade" command is
212 specifically instructed to remove them.  To do this, define
213 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
214 "make upgrade REMOVE_OPENSSL_FILES=yes"
215
216 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
217 stale OpenSSL files be removed to avoid configuration scripts from using
218 the stale and potentially vulnerable version, but all binaries that are
219 dynamically linked to the OpenSSL libraries should be rebuilt first to
220 avoid breakage.
221
222 OPENSSH HPN REMOVED
223 -------------------
224
225 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
226 To use OpenSSH in base remove HPN config, if you have added it.
227 Check files below for HPN config, see a few lines below.
228   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
229 sshd(8) will fail to start if HPN config is used.
230
231 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
232
233 HPN config:
234 HPNDisabled
235 HPNBufferSize
236 TcpRcvBuf
237 TcpRcvBufPoll
238 NoneEnabled
239 NoneSwitch
240 cipher MTR-AES-CTR
241 cipher NONE
242
243 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
244 circumstances, especially for networking.
245 If HPN functionality is needed, install security/openssh from dports.
246
247 CS, EX AND VX DRIVERS REMOVED
248 -----------------------------
249
250 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
251 old and its doubtful they ever worked properly in x86_64 but they were
252 in X86_64_GENERIC, so custom configurations derived from it have to be
253 adjusted.
254
255 +-----------------------------------------------------------------------+
256 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
257 +-----------------------------------------------------------------------+
258
259 AMD REMOVED
260 -----------
261
262 The am-utils automounter suite has been removed. It stopped working
263 at some point and was never fixed. autofs(5) and the associated
264 userland has been brought in from FreeBSD and replaces it.
265
266 AN DRIVER REMOVED
267 -----------------
268
269 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
270 config file, so any configurations derived from it have to be adjusted.
271
272 /DEV/DRI GROUP CHANGED
273 ----------------------
274
275 The default group assigned to /dev/dri entries has been changed
276 from 'wheel' to 'video' with the id of '44'. If you want to have
277 access to the dri devices please add yourself to the video group
278 with:
279
280 # pw groupmod video -m $USER
281
282 +-----------------------------------------------------------------------+
283 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
284 +-----------------------------------------------------------------------+
285
286 DSCHED REMOVED
287 --------------
288
289 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
290 in our default kernel config file. So the DSCHED_FQ option has been turned
291 into a no-op for now and can be removed from custom configurations.
292
293 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
294 -------------------------------------------------
295
296 The est(4) driver has been removed. All CPUs it supported (except one)
297 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
298 report back if there are any issues with this CPU and our regular ACPI
299 P-state support.
300
301 Also, compile_et(1) and com_err(3) have been removed as well. They
302 should have been removed along with kerberos support, back in 2009.
303
304 SEVERAL LOCALES RENAMED
305 -----------------------
306
307 Several locales were using obsolete and misleading names, and thus have
308 been adjusted to current standards. Any users of the following locales
309 need to select alternates:
310
311 DFLY 4.2 locale            DFLY 4.4 alterative locale
312 ---------------            ------------------------------------
313 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
314 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
315 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
316 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
317 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
318 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
319 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
320 zh_CN.GBK                  zh_Hans_CN.GBK
321 zh_CN.UTF-8                zh_Hans_CN.UTF-8
322 zh_CN.eucCN                zh_Hans_CN.eucCN
323 zh_CN.GB2312               zh_Hans_CH.GB2312
324 zh_CN.GB18030              zh_Hans_CH.GB18030
325 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
326 zh_HK.UTF_8                zh_Hant_HK.UTF-8
327 zh_TW.Big5                 zh_Hant_TW.Big5
328 zh_TW.UTF-8                zh_Hant_TW.UTF-8
329
330 +-----------------------------------------------------------------------+
331 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
332 +-----------------------------------------------------------------------+
333
334 BINUTILS 2.25 REPLACES 2.22, PRIMARY
335 ------------------------------------
336
337 The oldest of the two versions of Binutils, version 2.22, was removed
338 and replaced with Binutils 2.25.  It becomes the primary version version
339 of binutils and version 2.24 becomes the alternate.  There are 8 current
340 CVE written against 2.24, so for security reasons version 2.25 should
341 always be used.
342
343 The accepted values of BINUTILSVER are now "binutils225" (default) and
344 "binutils224".  The building of Binutils 2.24 can be prevented by setting
345 NO_ALTBINUTILS=yes in make.conf.
346
347 LOADER OPTIONS CHANGED
348 ----------------------
349
350 Right after the development branch started, the Fred art accompanying the
351 loader menu was improved.  The line between Fred and the menu was removed
352 by default (but can optionally be returned) and the placement shifted as
353 a result.  The drawing was improved, and the colored version was improved,
354 changing the eyes and wing color from white to red.  A new color version
355 of Fred was added, one with a blue scheme.
356
357 The loader menu defaults have changed since release 4.0:  The vertical
358 line was removed, the loader is displayed in color by default*, and the
359 blue scheme is used.
360
361 The loader.conf changes are:
362 loader_color:   option has been removed
363 loader_plain:   option has been added, it changed menu to monochrome
364 fred_is_red:    changes color scheme from blue to red
365 fred_is_blue:   option existed only on 4.1, it has been removed
366 fred_separated: Adds line between Fred and menu (as seen previously)
367
368 * If loader.conf defines "console" as "comconsole" or "console" is defined
369   in the environment as "comconsole" then color will not be displayed,
370   even if loader_plain value is "NO".
371
372 SENDMAIL REMOVED FROM BASE
373 --------------------------
374
375 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
376 If the system being upgraded is still configured to use the sendmail
377 binaries from base, the "make upgrade" command will fail.
378
379 The administrator must change /etc/mail/mailer.conf to switch the
380 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
381 command that permanently removes sendmail executables and could
382 potentially break a running mail server.
383
384 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
385 detailed instructions on how to configure the MTA selection.
386
387 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
388 --------------------------------------------
389
390 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
391 no-ops. They can be removed from custom kernel configurations.
392
393 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
394 --------------------------------------------
395
396 Many more sound devices may be detected.
397
398 If the default device chosen isn't to your liking, setting the sysctl
399 hw.snd.default_unit to a different number will change it.
400
401 SCTP SUPPORT DROPPED
402 --------------------
403
404 Support for the SCTP protocol has been removed.
405
406 OLD USB DRIVERS REMOVED
407 -----------------------
408
409 The old USB stack, along with the kernel config option "device oldusb"
410 and the make.conf variable "WANT_OLDUSB" have been removed. This means
411 that for custom kernel configuration files which were derived from a
412 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
413 various (old USB stack specific) devices will now complain about being
414 unknown:
415
416   * oldusb      (obviously)
417   * natausb     (not yet ported to usb4bsd)
418   * rue         (not yet ported to usb4bsd)
419   * ugen        (no longer needed in usb4bsd)
420   * urio        (not yet ported to usb4bsd)
421   * uscanner    (no longer needed in usb4bsd)
422
423 They should be removed or commented out in such custom kernel configs.
424
425 GCC 5
426 -----
427
428 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
429 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
430 NO_CXX.  The latter was never documented and the latest versions of GCC are
431 partially written in C++ so a C++ compiler is no longer optional.  In
432 practical terms it has not been optional for many years as other base
433 components are also written in C++.  The resource savings by avoiding
434 building Objective-C compiler is so small, the complexity added by NO_OBJC
435 internally was deemed a bad tradeoff so that is the reason for its removal.
436 Also note that no "info" pages are installed with GCC 5.  After this entry
437 was originally written, all info pages were removed from DragonFly.
438
439 GCC 5.1 has been designated as the primary compiler.  As such, there is a
440 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
441 the designated secondary compiler, GCC 4.7.  However, while DPorts
442 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
443 if building ports from source is desired, don't block building of the
444 secondary compiler.
445
446 +-----------------------------------------------------------------------+
447 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
448 +-----------------------------------------------------------------------+
449
450 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
451 -------------------------------------------
452
453 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
454 the default now (even on single-core systems), both for, like, 21 months.
455 We kept the options around as no-ops as a convenience, to allow people
456 using the same config for the then current release and the then current
457 master. That period is now over, so any configs still having those
458 options have to be adjusted.
459
460 SYSVIPC SYSCALLS MADE NON-OPTIONAL
461 ----------------------------------
462
463 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
464 now compiled in by default. The options are no-ops for now.
465
466 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
467 --------------------------------------------------------------------
468
469 The default driver for those controllers is now mrsas(4) due to reports
470 of file system corruption using the mfi(4) driver. The whole issue (and
471 how to deal with potential problems when switching) was explained here:
472
473 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
474
475 A tunable is provided for letting those controllers still attach via
476 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
477
478 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
479 ----------------------------------------
480
481 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
482 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
483 removed in kernel configs derived from X86_64_GENERIC.
484
485 +-----------------------------------------------------------------------+
486 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
487 +-----------------------------------------------------------------------+
488
489 UPDATE FROM MOST RECENT 3.6
490 ---------------------------
491
492 Versions of 3.6 built before June 25th have a bug where installworld might 
493 crash during installation of the new initrd.  Upgrade to the latest version
494 of 3.6 before updating to 3.8 or later.
495
496 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
497 --------------------------------------
498
499 Support for the IPX and NCP network protocols and for mouting NetWare
500 file systems has been dropped. Dito for ATM protocol support.
501
502 INITRD IMAGES NOW INSTALLED BY DEFAULT
503 --------------------------------------
504
505 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
506
507 Older images installed under the file name of initrd.img will be removed
508 automatically by the make upgrade process.
509
510 USB4BSD IS NOW THE DEFAULT USB STACK
511 ------------------------------------
512
513 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
514 replace "device usb" with "device oldusb" in the kernel configuration.
515
516 MORE ISA SUPPORT DROPPED
517 ------------------------
518
519 ISA support has been dropped from the following drivers: adv(4), an(4),
520 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
521 si(4), sn(4), and stg(4).
522
523 +-----------------------------------------------------------------------+
524 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
525 +-----------------------------------------------------------------------+
526
527 ABI CHANGE
528 ----------
529
530 Installed third-party software (dports) will have to be rebuilt after upgrade,
531 or reinstalled from binary packages.
532
533 UPDATING FROM 3.4 TO 3.6
534 ------------------------
535
536 This only applies for this specific upgrade due to locale changes; it is 
537 not needed for upgrades after 3.6.  Please update in this order:
538
539 make buildworld
540 make buildkernel
541 make installworld
542 make installkernel
543 *reboot*
544 make upgrade
545
546 See this mailing list post for details:
547 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
548
549 CYRIX OPTIONS REMOVED
550 ---------------------
551
552 The following Cyrix related options have been removed: CPU_BTB_EN,
553 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
554 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
555 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
556
557 ISA SUPPORT REMOVED FROM RP(4)
558 ------------------------------
559
560 ISA support has been removed from the rp(4) driver. It is now PCI only.
561
562 +-----------------------------------------------------------------------+
563 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
564 +-----------------------------------------------------------------------+
565
566 COMPAT_SUNOS OPTION REMOVED
567 ---------------------------
568
569 The COMPAT_SUNOS option has been removed. It was meant to provide binary
570 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
571
572 ISA SOUND CARD SUPPORT REMOVED
573 ------------------------------
574
575 The following modules have been removed (all for ISA sound cards):
576 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
577
578 GCC 4.7
579 -------
580
581 DragonFly has switched base compilers.  GCC 4.7 is now the default
582 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
583 variable ceases to work now.
584
585 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
586 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
587 highly discouraged.  There are a few packages in pkgsrc that do not build
588 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
589 this time, it is recommended to keep both compilers on the base system.
590
591 SMP OPTION REMOVED
592 ------------------
593
594 The SMP kernel option has been made a no-op. All kernels now feature SMP
595 support. If you have 'options SMP' in your kernel config, you can as well
596 remove it.
597
598 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
599 ---------------------------------------------------------------------------
600
601 The DEVICE_POLLING kernel option has been made a no-op and it has been
602 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
603 kernel config, you need to change it to IFPOLL_ENABLE.
604
605 Also, the KTR_POLLING kernel option has been removed, so it must be
606 removed from kernel configs that have it.
607
608 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
609 ---------------------------------------------------
610
611 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
612 cards will no longer be detected.
613
614 The same has been done for Stallion multiport serial controllers. stli(4)
615 has been completely removed (along with the stlload(8) and stlstty(8)
616 utilities) and stl(4) was changed to support only PCI cards. Similarly,
617 ISA support was removed from cy(4) too. All these drivers are i386 only.
618
619 COMPAT_OLDISA OPTION GONE
620 -------------------------
621
622 The i386 specific COMPAT_OLDISA kernel option has been removed, since
623 nothing needs it anymore.
624
625 +-----------------------------------------------------------------------+
626 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
627 +-----------------------------------------------------------------------+
628
629 APIC_IO OPTION REMOVED
630 ----------------------
631
632 The APIC_IO kernel option is no longer accepted after having been without
633 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
634 If you have 'options APIC_IO' in your kernel config, you'll have to
635 remove it.
636
637 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
638 -----------------------------------------
639
640 The wdog framework is now compiled into our kernels by default, so the
641 options are no longer needed.
642
643 DOSCMD(1) REMOVED
644 -----------------
645
646 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
647 NO_X make.conf option was removed too.
648
649 GCC 4.7
650 -------
651
652 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
653 default compiler in base (default is still GCC 4.4).
654
655 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
656 NO_GCC47 in /etc/make.conf.
657
658 USB4BSD
659 -------
660
661 A new USB stack (from FreeBSD) has been brought in. The following
662 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
663 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
664 and uaudio.
665
666 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
667 be put in make.conf and device "usb4bsd" (quotes needed) has to
668 replace device usb in the kernel config. After that, a full
669 build/install/upgrade cycle is needed.
670
671 Note that this is experimental and incomplete, but we are interested
672 in hearing about issues with it, of course.
673
674 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
675 ---------------------------------------------
676
677 ISA adapter support was dropped from the aic(4) driver.
678
679 +-----------------------------------------------------------------------+
680 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
681 +-----------------------------------------------------------------------+
682
683 SEVERAL ISA DRIVERS REMOVED
684 ---------------------------
685
686 The following ISA only drivers have been removed along with a couple of
687 associated userland tools:
688
689 aha(4)
690 asc(4) & sasc(1)
691 ctx
692 dgb(4)
693 el(4)
694 gpib
695 gsc(4) & sgsc(1)
696 ie(4)
697 labpc(4)
698 le(4)
699 mse(4)
700 rc(4)
701 rdp(4)
702 spigot
703 tw(4) & xten(1) & xtend(8)
704 wl(4) & wlconfig(8)
705 wt(4)
706
707 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
708 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
709 file.
710
711 If buildkernel complains about any of these drivers, just remove them
712 from your kernel configuration.
713
714 BINUTILS 2.20
715 -------------
716 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
717 values of BINUTILSVERS are now binutils221 and binutils222 (default).
718
719 BUILDWORLD/-KERNEL PARALLELIZATION WORK
720 ---------------------------------------
721 Due to changes in the way we build with more than one make job, you
722 will have to update install(1) and mkdir(1) prior to buildworld if you
723 want to build with 'make -j':
724
725 cd /usr/src/usr.bin/xinstall; make; make install; make clean
726 cd /usr/src/bin/mkdir; make; make install; make clean
727
728 DMA(8) UPGRADE
729 --------------
730 dma(8) has been upgraded to v0.7 which no longer supports the
731 /etc/dma/virtusertable. Some of its functionality has been replaced
732 with the MASQUERADE keyword and the EMAIL environment variable (see
733 the dma(8) manual page).
734
735 +-----------------------------------------------------------------------+
736 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
737 +-----------------------------------------------------------------------+
738
739 GCC 4.4 & BINUTILS 2.21
740 -----------------------
741
742 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
743 been made DragonFly's default Binutils.
744
745 That means that any settings that set CCVER to 'gcc44' are not needed
746 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
747 GCC 4.1.
748
749 It also means that 'binutils221' as a value for BINUTILSVER has no
750 effect anymore. 2.17 has been removed and 'binutils220' is available
751 as an option.
752
753 The NO_GCC44 option has been removed and will not affect the build
754 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
755 building in a similar fashion.
756
757 Note that you must do a full buildworld/buildkernel for upgrading.
758
759 pkg_radd settings
760 -----------------
761
762 The config file for pkg_radd has moved from /etc/settings.conf to 
763 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
764 if this is needed.  This warning only applies if /etc/settings.conf 
765 exists.  pkg_radd will continue to work with defaults.
766
767 +-----------------------------------------------------------------------+
768 +         20100927                                                      +
769 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
770 +-----------------------------------------------------------------------+
771
772 OpenSSL
773 --------
774
775 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
776 This shouldn't break any 3rd-party software, but you'll need to recompile your
777 3rd-party software if you want it to link against the new version of OpenSSL.
778
779 Loader
780 -------
781
782 A new loader (dloader) has been added which better handles booting from
783 multiple kernel/module versions.
784
785 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
786
787         cd /usr/src
788         make buildworld
789         make installworld
790         make upgrade
791         make buildkernel KERNCONF=<KERNELNAME>
792         make installkernel KERNCONF=<KERNELNAME>
793
794 Note that you must installworld and run the 'upgrade' target before
795 installing the new kernel.
796
797 BIND
798 -----
799
800 BIND has been removed from the base system.  The ldns and drill tools have 
801 been added for basic functionality.  Use 'drill' where you would normally 
802 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
803 net/bind95, net/bind96, or net/bind97 as of this writing.
804
805 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
806 include BIND as a pkgsrc package.
807
808 +-----------------------------------------------------------------------+
809 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
810 +                               GENERAL                                 +
811 +-----------------------------------------------------------------------+
812
813 Instructions on how to obtain and maintain DragonFly source code using git
814 are in the development(7) manual page.
815
816 To upgrade a DragonFly system from sources you run the following sequence:
817
818         cd /usr/src
819         make buildworld
820         make buildkernel KERNCONF=<KERNELNAME>
821         make installkernel KERNCONF=<KERNELNAME>
822         make installworld
823
824 You will also want to run the 'upgrade' target to upgrade your /etc and the
825 rest of your system.  The upgrade target is aware of stale files created by
826 older DragonFly installations and should delete them automatically.
827
828         make upgrade
829
830 See the build(7) manual page for further information.
831
832 Once you've done a full build of the world and kernel you can do incremental
833 upgrades of either by using the 'quickworld' and 'quickkernel' targets
834 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
835 the quick targets, try updating your repo first, and then a full buildworld
836 and buildkernel as shown above, before asking for help.
837
838 +-----------------------------------------------------------------------+
839 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
840 +-----------------------------------------------------------------------+
841
842 In 2.1 kernel and modules has moved to boot directory.  For most cases
843 this is handled automatically by 'make upgrade'.  A few cases needs manual
844 intervention:
845
846  * When installing a kernel without first doing a make buildworld,
847    installworld and upgrade to the same DESTDIR as kernel:
848    make DESTDIR/boot directory and move kernel and modules into this boot
849    directory; also move kernel.old and modules.old.
850    Typical example is vkernel(7), use (no modules used):
851
852         cd /var/vkernel
853         mkdir boot
854         chflags noschg kernel
855         mv kernel kernel.old boot
856         chflags schg boot/kernel
857         
858  * When using a boot-only partition, /boot/loader.rc needs to be edited:
859    delete occurrences of '/boot/'.
860    These occurrences can normally be deleted in any case, see loader(8).
861
862 +-----------------------------------------------------------------------+
863 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
864 +-----------------------------------------------------------------------+
865
866 In 1.9 major changes to the disk management infrastructure have taken
867 place.  make upgrade may not catch all of your disk devices in /dev,
868 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
869 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
870 and MAKEDEV no longer exists.
871
872 The biggest changes in 1.9 are:
873
874 (1) That whole-slice devices such as da0s1 no longer share the same device
875     id as partition c devices such as da0s1c.
876
877 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
878     with no snooping or reserved sectors.  Consequently you cannot run
879     disklabel on this device.  Instead you must run disklabel on a
880     whole-slice device.
881
882 (3) The 'compatibility' partitions now use slice 0 in the device name,
883     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
884     accessing the disklabel for the compatibility partitions must be
885     done via slice 0 (da0s0).
886
887 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
888     and CCD now run through the disk management layer and are assigned
889     real disk management devices.   VN and CCD in particular do not usually
890     use a MBR and disklabels must be accessed through the compatibility
891     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
892     don't name it 'ccd0s0' in the config file.
893
894 Generally speaking, you have to get used to running fdisk and disklabel on
895 the correctly specified device names.  A lot of the wiggle, such as running
896 disklabel on a partition, has been removed.
897
898 +-----------------------------------------------------------------------+
899 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
900 +-----------------------------------------------------------------------+
901
902 > Kerberos IV
903 -------------
904
905 Kerberos IV (eBones) was removed from the tree, please consider moving to
906 Kerberos 5 (Heimdal).
907
908 > Package Management System
909 ---------------------------
910
911 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
912 management system.  The necessary tools to build and maintain packages
913 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
914 directories are in your PATH variable.
915
916 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
917 the tarball from NetBSD:
918
919         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
920         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
921
922 This tree can then be kept up to date with cvs update:
923
924         cd /usr/pkgsrc; cvs up
925
926 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
927 build and install the pkgsrc bootstrap manually:
928
929         cd /usr/pkgsrc/bootstrap
930         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
931
932 +-----------------------------------------------------------------------+
933 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
934 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
935 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
936 +-----------------------------------------------------------------------+
937
938 The compatibility shims for the build environment have been removed, you
939 have to update to DragonFly 1.2 release branch first.
940
941 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
942 The existing configuration can be converted using /etc/pam.d/convert.sh.
943 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
944 the pam_skey.so module was retired, you have to remove it manually from
945 your configuration, when you convert it.
946
947 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
948 ---------------------
949
950 The following users may be missing from your password file.  Use vipw and
951 add any that are missing:
952
953 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
954 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
955
956 The following groups may be missing from your group file.  Use vi /etc/group
957 and add any that are missing:
958
959 smmsp:*:25:
960 authpf:*:63:
961 _pflogd:*:64:
962
963
964 > Upgrading to DragonFly from FreeBSD
965 ---------------------
966
967 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
968 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
969 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
970 make depend information, it starts from scratch, so no pre-cleaning of the
971 object hierarchy is necessary.
972
973         # get the CVS repository (it is placed in /home/dcvs, 500MB).
974         # Please use the -h option and a mirror site to pull the 
975         # initial repository, but feel free to use the main repository
976         # machine to pull updates.
977         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
978         # install the source from the CVS hierarchy (remove preexisting
979         # FreeBSD src first) (500MB)
980         cd /usr
981         rm -rf src
982         cvs -R -d /home/dcvs checkout -P src
983
984         # build it (500MB used in /usr/obj)
985         #
986         cd /usr/src
987         make buildworld
988         make buildkernel KERNCONF=<KERNELNAME>
989
990 Once you have built DragonFly you have to install it over FreeBSD.  Since
991 DragonFly does not track changes made by FreeBSD to its include file 
992 hierarchy and include file pollution can cause all sorts of unexpected
993 compilation issues to come up, it is best to wipe your include hierarchy
994 prior to installing DragonFly.  Note that you should not wipe any installed
995 FreeBSD header files or binaries until after you have successfully completed
996 the build steps above.
997
998         rm -rf /usr/include
999         mkdir /usr/include
1000         make installkernel KERNCONF=<KERNELNAME>
1001         make installworld
1002
1003 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
1004 will unconditionally upgrade the /etc files that sysops do not usually
1005 mess around with, such as the files in /etc/rc.d.  It will also remove any
1006 obsolete files such as utilities and manpages that have been removed from
1007 the system since the version you're coming from.  If you are unsure we 
1008 recommend that you make a backup of at least your /etc before applying
1009 this step.  Note that DragonFly's RC system is basically RCNG from
1010 FreeBSD-5, but there are some differences in the contents of the RC files.
1011
1012         make upgrade
1013
1014 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
1015 Doing so might leave your system in an unusable state.
1016
1017 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
1018 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
1019 report these files to the DragonFly developers so that they can be added to
1020 the 'upgrade' target.
1021